package org.kozyrev.gui.classchooser;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.kozyrev.gui.util.ClassFilter;
import org.kozyrev.gui.util.ClassFilter.Politic;

public class ClassControlBox extends JPanel {

    /**
     * Generated serial version ID
     */
    private static final long serialVersionUID = 5272555504372969097L;
    
    private JList myControl;
    public ClassControlBox() {
        this.setLayout(new FlowLayout());
        this.add(getRadioButtons());
        this.add(new JButton(new AddAction()));
    }
    
    public void setList(JList control) {
        myControl = control;
    }
    
    @SuppressWarnings("serial")
    private JPanel getRadioButtons() {
        JPanel contentPanel = new JPanel();
        contentPanel.setOpaque(false);

        ButtonGroup filteringCase = new ButtonGroup();

        contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.Y_AXIS));

        JRadioButton without = new JRadioButton("Without filtering", true) {
            {
                addActionListener(new PoliticChangeListener(Politic.NO_ACTION));
            }
        };
        
        JRadioButton include = new JRadioButton("Accept") {
            {
                addActionListener(new PoliticChangeListener(Politic.ACCEPT));
            }
        };
        
        JRadioButton exclude = new JRadioButton("Reject") {
            {
                addActionListener(new PoliticChangeListener(Politic.DECLINE));
            }
        };
        
        without.setOpaque(false);
        include.setOpaque(false);
        exclude.setOpaque(false);

        filteringCase.add(include);
        filteringCase.add(exclude);
        filteringCase.add(without);

        contentPanel.add(include);
        contentPanel.add(exclude);
        contentPanel.add(without);

        return contentPanel;
    }

    
    private class PoliticChangeListener implements ActionListener {
        
        private Politic myPolitic;
        
        public PoliticChangeListener(Politic p) {
            myPolitic = p;
        }
        
        public void actionPerformed(ActionEvent e) {
            ClassFilter.getInstance().setPolitic(myPolitic);
        }
    }
    
    private class AddAction extends AbstractAction {

        /**
         * Generated serial version ID
         */
        private static final long serialVersionUID = -6807223029418189286L;

        public AddAction() {
            ClassLoader cl = this.getClass().getClassLoader();
            ImageIcon addIcon = new ImageIcon(cl
                    .getResource("images/list-add.png"));

            this.putValue(Action.SMALL_ICON, addIcon);
            this.putValue(Action.NAME, "Add new");
        }

        public void actionPerformed(ActionEvent e) {
            String newRule = JOptionPane.showInputDialog("Enter new rule", "");
            if (newRule != null) {                
                  JList contentList = myControl;
                  ClassListModel model = (ClassListModel) contentList.getModel();
                  model.addElement(new Option(newRule, true));
            }

        }
    }
}

