package org.kozyrev.gui.util;

import java.util.LinkedList;

import javax.swing.Action;

/**
 * Reptesents global state of UI based on action control 
 * 
 * @author Paul
 *
 */

public class GlobalState {
    
    private LinkedList<Action> myActionList = new LinkedList<Action>();
    
    public GlobalState() {
        
    }
    
    public void addAction(Action action) {
        if (!myActionList.contains(action)) {
            myActionList.add(action);    
        }    
    }
    
    public void removeAction(Action action) {
        myActionList.remove(action);
    }
    
    public void enable() {
        for (Action act : myActionList) {
            act.setEnabled(true);
        }
    }
    
    public void disable() {
        for (Action act : myActionList) {
            act.setEnabled(false);
        }
    }
    
    public void clear() {
        myActionList.clear();
    }
    
}
