package org.kozyrev.gui.util;

import java.util.LinkedList;

public class GlobalStateManager {
    
    private LinkedList<GlobalState> myStates = new LinkedList<GlobalState>();
    
    public GlobalStateManager() {
        
    }
    
    public void addState(GlobalState state) {
        myStates.add(state);
    }
    
    public void removeState(GlobalState state) {
        myStates.remove(state);
    }
    
    public void clear() {
        myStates.clear();
    }
    
    /**
     * If manager do not contain state then state of manager stay without changes.
     * 
     * @param state
     */
    public void setState(GlobalState state) {
        
        if (myStates.contains(state)) {
            for (GlobalState s : myStates) {
                s.disable();
            }
            
            state.enable();
        }
        
    }

}
