package org.kozyrev.log;

import org.apache.log4j.PropertyConfigurator;

public class LogConfigurator {

    private LogConfigurator() {
    }
    
    public static void configure(LoggerConfiguration cfgType) {
        cfgType.configure();
    }
    
    public enum LoggerConfiguration {
        
        JUNIT() {
            private final String LOGGER_CONFIG_FILE_NAME = "junit.log.properties"; 
            
            protected void configure() {
                PropertyConfigurator.configure(LOGGER_CONFIG_FILE_NAME);
            };
        },
        
        DEFAULT() {
            private final String LOGGER_CONFIG_FILE_NAME = "log.properties"; 
            
            protected void configure() {
                PropertyConfigurator.configure(LOGGER_CONFIG_FILE_NAME);
            };
        };
        
        protected abstract void configure();
    }
}
