package org.kozyrev.model;

import java.util.ArrayList;
import java.util.List;

public class ClassRecord {
    
    private ArrayList<MethodRecord> myMethods = new ArrayList<MethodRecord>();
    private ArrayList<MethodRecord> myConstructors = new ArrayList<MethodRecord>();
    private String myName;
    private String myShortName;
    private int myCount;

    public ClassRecord(String name, String shortName, int count) {
        myName = formatClassName(name);
        myShortName = shortName;
        myCount = count;        
    }
    
    public List<MethodRecord> getMethods() {
        return myMethods;
    }
    
    public List<MethodRecord> getConstructors() {
        return myConstructors;    
    }
    
    public String getName() {
        return myName;    
    }
    
    public String getShortName() {
        return myShortName;
    }
    
    public String getPackage() {
        return myName.substring(0, myName.length() - myShortName.length() - 1);        
    }
    
    public int getAllocationCount() {
        return myCount;
    }
    
    public void addMethod(MethodRecord method) {
        myMethods.add(method);
    }
    
    public void addConstructor(MethodRecord constructor) {
        myConstructors.add(constructor);
    }    
    
    private String formatClassName(String name) {
        return name.replaceAll("/", ".");
    }
}
