package org.kozyrev.tests;

import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;
import org.kozyrev.gui.util.ClassFilter;
import org.kozyrev.gui.util.ClassFilter.Politic;
import org.kozyrev.log.LogConfigurator;
import org.kozyrev.log.LogConfigurator.LoggerConfiguration;

public class TestClassFilter {

    @BeforeClass
    public static void setUpBeforeClass() {
        LogConfigurator.configure(LoggerConfiguration.JUNIT);
    }
    
    @Test
    public void testPackageFilter() {
        ClassFilter filter = ClassFilter.getInstance();
        filter.setPolitic(Politic.ACCEPT);
        
        filter.addPackageRegExp("java.*");
        
        Assert.assertTrue(filter.accept("java.lang.op.OOml"));
        
        
        filter.clear();
        
        filter.addPackageRegExp("java.lang");
                
        Assert.assertTrue(filter.accept("java.lang"));
        Assert.assertTrue(!filter.accept("java,lang"));
        Assert.assertTrue(!filter.accept("java.lang.String"));
        
        filter.addPackageRegExp("java.lang.*");
        Assert.assertTrue(filter.accept("java.lang.String"));
        Assert.assertTrue(!filter.accept("java.awt"));
        
        filter.clear();
        filter.addPackageRegExp("c.");
        Assert.assertTrue(filter.accept("c."));
        
        
    }
}
