package org.kozyrev.tests;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import org.apache.log4j.Logger;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;
import org.kozyrev.log.LogConfigurator;
import org.kozyrev.log.LogConfigurator.LoggerConfiguration;
import org.kozyrev.net.ConnectionController;

public class TestConnectionController {

    private static final Logger LOG = Logger.getLogger(TestConnectionController.class);
    
    @BeforeClass
    public static void setUpBeforeClass() throws Exception {
        LogConfigurator.configure(LoggerConfiguration.JUNIT);
    }

    @Test
    public void testGetSocket() throws Exception {
        LOG.debug("Starting resolving host");
        ServerSocket ss = new ServerSocket(ConnectionController.getPortNumber());
        
        Socket s = null;
        
        try {
            s = ConnectionController.getSocket(15599);
        } catch (IOException e) {
            LOG.error("Host has'nt been found.", e);
            Assert.fail();
            return;
        }
        
        LOG.debug("Host has been found");        
        Assert.assertTrue(s != null);       

        ss.close();
   }

}
